/*
	Hello Web 3 - The Button Strikes!
	Exploring Java - Niemeyer & Peck
*/

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class HelloWeb3a extends Applet
	implements MouseMotionListener, ActionListener {

	int messageX = 50, messageY = 60;
	String theMessage;
	Font theFont = new Font("Helvetica",Font.BOLD,24);
	Button theButton;
	int colorIndex = 0;
	static Color[] someColors = {
		Color.black, Color.red, Color.green, Color.blue, Color.magenta };
		
	public void init() {
		theMessage = getParameter("message");
		theButton = new Button("Change Color");
		add( theButton );
		addMouseMotionListener( this );
		theButton.addActionListener( this );
		repaint();
	}
	
	public void paint( Graphics g ) {
		g.setFont( theFont );
		g.drawString( theMessage, messageX, messageY );
	}

	public void mouseDragged( MouseEvent e ) {
		messageX = e.getX();
		messageY = e.getY();
		repaint();
	}
	
	public void mouseMoved( MouseEvent e ) { }

	public void actionPerformed( ActionEvent e ) {
		if ( e.getSource() == theButton ) {
			changeColor();
		}
	}

	synchronized private void changeColor() {
		if ( ++colorIndex == someColors.length )
			colorIndex = 0;
		setForeground( currentColor() );
		repaint();
	}

	synchronized private Color currentColor() {
		return someColors[ colorIndex ];
	}
}

