package ShapePack;

/** 
	The Shape class is an abstract class which defines the fields, methods
    and behavior common to all shapes.
*/

import java.awt.*;

public abstract class Shape {
	static public final int defaultWidth = 20, defaultHeight = 10;
	static public final Color defaultColor = Color.red;
   
	protected Color color;
	protected int x;
	protected int y;
	protected int wide;
	protected int high;

	public Shape(int x, int y, int w, int h, Color c) {
		this.x = x;
		this.y = y;
		this.wide = w;
		this.high = h;
		this.color = c;
	}
	
	public void moveTo(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public int getX() {
		return( x );
	}
	
	public int getY() {
		return( y );
	}
	
	public int getWidth() {
		return( wide );
	}
	
	public int getHeight() {
		return( high );
	}
	
	public void setWidth( int w ) {
		wide = w;
	}
	
	public void setHeight( int h ) {
		high = h;
	}

	abstract public void draw(Graphics g);

	abstract public float area();

	abstract public float perimeter();
	
	public String toString() {
		String myInfo;
		myInfo = "at (" + x + "," + y + "), ";
		myInfo += wide + " pixels wide, " + high + " pixels high.\n";
		myInfo += color;
		return( myInfo );
	}
}


