import java.util.*;

public class Edge implements Comparable {
	protected Comparable source;
	protected Comparable target;
	
	public Edge(Comparable source, Comparable target) {
		if (0 < source.compareTo(target)) { 
			this.source = target;
			this.target = source;
		} else {
			this.source = source;
			this.target = target;
		}		
	}
	
	public Comparable getSource() {
		return source;
	}
	
	public Comparable getTarget() {
		return target;
	}
	
	public int compareTo(Object e) {
		if (e instanceof Edge) {
			int t = source.compareTo(((Edge)e).getSource());
			if (t == 0) {
				t = target.compareTo(((Edge)e).getTarget());
			}
			return t;
		} else {
			throw new ClassCastException("Not an edge");
		}
	}
	
	public String toString() {
		return "{ " + source + ", " + target + " }";
	} 
	
	public static void main(String[] args) {
		Edge e = new Edge("xyz","abc");
		System.out.println( e );
	} 
}

