public class M865TreeNode {

	protected M865Vertex vertex;
	protected M865TreeNode parent;
	protected M865TreeNode leftChild;
	protected M865TreeNode rightChild;
	
	public M865TreeNode(M865Vertex vertex, M865TreeNode parent,
		M865TreeNode leftChild, M865TreeNode rightChild) {
		this.vertex = vertex;
		this.parent = parent;
		this.leftChild = leftChild;
		this.rightChild = rightChild;
	}
	
	public M865Vertex getVertex() {
		return vertex;
	}

	public void setVertex(M865Vertex vertex) {
		this.vertex = vertex;
	}

	public M865TreeNode getParent() {
		return parent;
	}

	public void setParent(M865TreeNode parent) {
		this.parent = parent;
	}

	public M865TreeNode getLeftChild() {
		return leftChild;
	}

	public void setLeftChild(M865TreeNode leftChild) {
		this.leftChild = leftChild;
	}

	public M865TreeNode getRightChild() {
		return rightChild;
	}

	public void setRightChild(M865TreeNode rightChild) {
		this.rightChild = rightChild;
	}

	public boolean equals(Object t) {
		if (t instanceof M865TreeNode) {
			M865TreeNode tree = (M865TreeNode)t;
			boolean b = vertex.equals((M865Vertex)tree.getVertex());
			b = b && parent.getVertex().equals((M865Vertex)tree.getParent().getVertex());
			b = b && leftChild.getVertex().equals((M865Vertex)tree.getLeftChild().getVertex());
			b = b && rightChild.getVertex().equals((M865Vertex)tree.getRightChild().getVertex());
			return b;
		} else {
			throw new ClassCastException("Not a TreeNode");
		}
	}

	public int hashCode() {
		long hash = vertex.hashCode();
		hash = (hash + parent.getVertex().hashCode()) % Integer.MAX_VALUE;
		hash = (hash + leftChild.getVertex().hashCode()) % Integer.MAX_VALUE;
		hash = (hash + rightChild.getVertex().hashCode()) % Integer.MAX_VALUE;
		return (int)hash;
	}

	public String toString() {
		return vertex.toString();
	}

	public void addChild(M865TreeNode child) {
		child.setParent(this);
		if (this.leftChild == null) {
			this.leftChild = child;
		} else {
			this.leftChild.addSybling(child);
		}
	}
	
	public void addSybling(M865TreeNode child) {
		child.setParent(this.parent);
		if (this.rightChild == null) {
			this.rightChild = child;
		} else {
			this.rightChild.addSybling(child);
		}
	}

	protected void printSubTree(String prompt) {
		System.out.println(prompt + vertex);
		if (leftChild != null) {
			leftChild.printSubTree(prompt+"|  ");
		}
		if (rightChild != null) {
			rightChild.printSubTree(prompt);
		}
	}
	
	public void printTree() {
		System.out.println(vertex);
		if (leftChild != null) {
			leftChild.printSubTree("|  ");
		}
	}
	
	public static void main(String[] args) {
		M865TreeNode v000 = new M865TreeNode(new M865Vertex("Don"), null, null, null);
		M865TreeNode v100 = new M865TreeNode(new M865Vertex("Dan"), null, null, null);
		M865TreeNode v200 = new M865TreeNode(new M865Vertex("Jeff"), null, null, null);
		M865TreeNode v300 = new M865TreeNode(new M865Vertex("Peggy"), null, null, null);
		M865TreeNode v400 = new M865TreeNode(new M865Vertex("Terry"), null, null, null);
		M865TreeNode v500 = new M865TreeNode(new M865Vertex("Mo"), null, null, null);
		M865TreeNode v110 = new M865TreeNode(new M865Vertex("Doug"), null, null, null);
		M865TreeNode v120 = new M865TreeNode(new M865Vertex("Russell"), null, null, null);
		M865TreeNode v130 = new M865TreeNode(new M865Vertex("Mandy"), null, null, null);
		M865TreeNode v210 = new M865TreeNode(new M865Vertex("Chuck"), null, null, null);
		M865TreeNode v220 = new M865TreeNode(new M865Vertex("Ed"), null, null, null);
		M865TreeNode v410 = new M865TreeNode(new M865Vertex("Tim"), null, null, null);
		M865TreeNode v420 = new M865TreeNode(new M865Vertex("Nate"), null, null, null);
		M865TreeNode v430 = new M865TreeNode(new M865Vertex("Jennifer"), null, null, null);
		M865TreeNode v440 = new M865TreeNode(new M865Vertex("Jamie"), null, null, null);
		M865TreeNode v450 = new M865TreeNode(new M865Vertex("Vanessa"), null, null, null);
		M865TreeNode v510 = new M865TreeNode(new M865Vertex("Danielle"), null, null, null);
		M865TreeNode v520 = new M865TreeNode(new M865Vertex("Erica"), null, null, null);
		M865TreeNode v221 = new M865TreeNode(new M865Vertex("Gabriel"), null, null, null);
		M865TreeNode v421 = new M865TreeNode(new M865Vertex("Lilly Anna"), null, null, null);
		M865TreeNode v422 = new M865TreeNode(new M865Vertex("McKenna"), null, null, null);
		M865TreeNode v431 = new M865TreeNode(new M865Vertex("Riley"), null, null, null);
		M865TreeNode v441 = new M865TreeNode(new M865Vertex("Haley"), null, null, null);
		M865TreeNode v511 = new M865TreeNode(new M865Vertex("Avery"), null, null, null);
		M865TreeNode v512 = new M865TreeNode(new M865Vertex("Sidney"), null, null, null);
		
		v000.addChild(v100);
		v000.addChild(v200);
		v200.addSybling(v300);
		v000.addChild(v400);
		v000.addChild(v500);
		
		v100.addChild(v110);
		v100.addChild(v120);
		v110.addSybling(v130);

		v200.addChild(v210);
		v200.addChild(v220);
		v220.addChild(v221);

		v400.addChild(v410);
		v400.addChild(v420);
		v400.addChild(v430);
		v400.addChild(v440);
		v400.addChild(v450);
		v420.addChild(v421);
		v420.addChild(v422);
		v430.addChild(v431);
		v440.addChild(v441);

		v500.addChild(v510);
		v500.addChild(v520);
		v510.addChild(v511);
		v510.addChild(v512);

		v000.printTree();
		
		System.out.println("parent of " + v000 + "\t is " + v000.getParent());
		System.out.println("parent of " + v100 + "\t is " + v100.getParent());
		System.out.println("parent of " + v300 + "\t is " + v300.getParent());
		System.out.println("parent of " + v130 + "\t is " + v130.getParent());
		System.out.println("parent of " + v500 + "\t is " + v500.getParent());
		System.out.println("parent of " + v510 + "\t is " + v510.getParent());
		System.out.println("parent of " + v512 + "\t is " + v512.getParent());
		
		v400.printTree();
	}

}	
