import java.awt.Color;
import java.awt.Graphics;
import java.util.Iterator;

import m865.datastructures.StackAL;
import m865.shapepack.Rectangle;

public class Post extends Rectangle {

	protected StackAL myRings;
	protected int nextRing;
	
	public Post(int x, int y, int w, int h, Color c) {
		super(x, y, w, h, c);
		myRings = new StackAL();
		nextRing = height;
	}

	public int getNextRing() {
		return nextRing;
	}

	public void push(Rectangle ring) {
		int w = ring.getWidth();
		int h = ring.getHeight();
		int xr = x - (w - width)/2;
		int yr = y + (nextRing - h);
		nextRing -= (h+1);
		ring.moveTo(xr,yr);
		myRings.push(ring);
	}

	public Rectangle pop() {
		Rectangle ring = (Rectangle)myRings.pop();
		int h = ring.getHeight();
		nextRing += (h+1);
		return ring;
	}
	
	public void clear() {
		myRings.clear();
		nextRing = height;
	}
	
	public void draw(Graphics g) {
		super.draw(g);
		Iterator iter = myRings.iterator();
		while (iter.hasNext()) {
			Rectangle ring = (Rectangle)iter.next();
			ring.draw(g);
		}
	}
}
