public class XMLLine {
    public static final int INDENT_INC = 3, MAX_INDENT = 48, LINE_LENGTH = 72;

    protected String myLine;
    protected String myIndent;
    
    public XMLLine(String indent) {
        if (MAX_INDENT < indent.length()) {
            myIndent = indent.substring(0, MAX_INDENT);
        } else {
            myIndent = indent;
        }
        myLine = myIndent;
    }
    
    public void bumpIndent() {
        String tmp = myLine.substring(myIndent.length());
        for (int k=0; k<INDENT_INC; k++) {
            if (myIndent.length() < MAX_INDENT) {
                myIndent += " ";
            }
        }
        myLine = myIndent + tmp;
    }
    
    public void output(String s) {
        this.flush();
        myLine += s;
        this.flush();
    }
        
    public void add(String s) {
        myLine += s;
        if (LINE_LENGTH < myLine.length()) {
            this.flush();
        }
    }
    
    public void flush() {
        if (myIndent.length() < myLine.length()) {
            System.out.println( myLine );
            myLine = myIndent;
        }
    }
    
    public String getIndent() {
        return myIndent;
    }
}
